;
; the Sweeper registration keys generator (keygen) (c) 2000 CTHC
;
 model  tiny
.386
 assume cs:@code, ds:@data
 codeseg

 key_size              equ (end_of_key-name_)

 start:         mov     ax,@data
                mov     ds,ax
                mov     es,ax

                call    calculate_ip
 calculate_ip:  pop     bp
                sub     bp,offset calculate_ip

 get_name:      mov     ah,9
                lea     dx,[bp+msg_your_name]
                int     21h

                mov     ax,58
                lea     si,[bp+name_]
                push    si
                lea     di,[bp+string_ok]
                call    save_string

                pop     si
                xchg    cx,di
                call    calculate_crc
                mov     word ptr [bp+name_crc16],ax

 get_org:       mov     ah,9
                lea     dx,[bp+msg_organization_name]
                int     21h

                mov     ax,52
                lea     si,[bp+organization]
                push    si
                lea     di,[bp+string_ok]
                call    save_string

                pop     si
                xchg    cx,di
                call    calculate_crc
                mov     word ptr [bp+organization_crc16],ax

 get_email:     mov     ah,9
                lea     dx,[bp+msg_your_email]
                int     21h

                mov     ax,32
                lea     si,[bp+email]
                push    si
                lea     di,[bp+string_ok]
                call    save_string

                pop     si
                xchg    cx,di
                call    calculate_crc
                mov     word ptr [bp+email_crc16],ax

 gen_random_bl:
                mov     cx,(142/2)
                lea     di,[bp+random_block]
                push    cx di
 junk_loop:     in      ax,40h
                in      al,40h
                stosw
                loop    junk_loop

                pop     si di
                call    calculate_crc
                mov     word ptr [bp+random_block_crc16],ax

 clc_crc16_all: lea     si,[bp+name_]
                push    si si
                mov     cx,(key_size-2)
                call    calculate_crc

 crypt_block:   mov     cx,(key_size)
                pop     di si
 crypt_loop:    lodsb
                not     al
                xor     al,6
 _ror_al_11             db 0C0h,0C8h,011h
                stosb
                loop    crypt_loop

 create_key:    mov     ah,3ch
                sub     cx,cx
                lea     dx,[bp+sweeper_key]
                int     21h
                jnc     move_handle

 creation_er:   mov     ah,9
                lea     dx,[bp+msg_error_creation]
                int     21h
                jmp     exit_to_os

 move_handle:   xchg    bx,ax

                mov     ah,40h
                mov     cx,(key_size)
                lea     dx,[bp+name_]
                int     21h

                mov     ah,3eh
                int     21h

 exit_to_os:    mov     ax,4c00h
                int     21h
;
; calculate_crc - calculate crc 16
;
; on start ds:si - data
;          ds:di - size of data
;
; return   ds:ax - crc16
;
 calculate_crc: cld
                push    cx dx bx si
                mov     cx,-1
                mov     dx,cx

 next_byte:     sub     ax,ax
                sub     bx,bx
                lodsb
                xor     al,cl
                mov     cl,ch
                mov     ch,dl
                mov     dl,dh
                mov     dh,8 

 next_bit:      shr     bx,1
                rcr     ax,1
                jnc     no_carry
                xor     ax,8320h
                xor     bx,0edb8h

 no_carry:      dec     dh
                jnz     next_bit
                xor     cx,ax
                sub     dx,bx
                dec     di
                jnz     next_byte
                not     dx
                not     cx
                mov     ax,dx
                ror     ax,cl
                add     ax,cx
                pop     si bx dx cx
                ret
;
; save_string - save string
;
; ds:ax - max string size
; ds:si - buffer
; ds:di - okey symbols, ended with zero
;
; ds:cx - string size
;
 save_string:   mov     word ptr [bp+string_cnt],0
                mov     word ptr [bp+max_string],ax

 save_str_loop: sub     ax,ax
                int     16h

                cmp     al,0dh
                jz      end_input
                cmp     al,08h
                jz      back_space

                mov     dx,word ptr [bp+string_cnt]
                cmp     word ptr [bp+max_string],dx
                jz      save_str_loop

                push    di                
 check_symbol:  cmp     byte ptr [di],0
                jnz     continue_chk
 symbols_ended: pop     di
                jmp     save_str_loop

 continue_chk:  cmp     byte ptr [di],al
                jz      symbol_ok

 next_symbol:   inc     di
                jmp     check_symbol                
               
 symbol_ok:     pop     di
                inc     word ptr [bp+string_cnt]
                mov     byte ptr [si],al
                inc     si
                call    stdout
                jmp     save_str_loop
                ret

 end_input:     mov     cx,word ptr [bp+string_cnt]
                ret

 back_space:    cmp     word ptr [bp+string_cnt],0
                jz      save_str_loop

                dec     word ptr [bp+string_cnt]
                dec     si
                mov     byte ptr [si],0

                call    get_xy
                dec     dl
                push    dx
                call    goto_xy
                mov     al,' '
                call    stdout
                pop     dx
                call    goto_xy

                jmp     save_str_loop
;
; goto_xy - move cursor to X,Y
;
; ds:dh - x
; ds:dl - y
;
 goto_xy:       mov     ah,2
                mov     bh,0
                int     10h
                ret
;
; get_xy - gets curent cursor position
;
; ds:dh - x
; ds:dl - y
;
 get_xy:        mov     ah,3
                mov     bh,0
                int     10h
                ret
;
; stdout - standart output
;
; ds:al - char
;
 stdout:        push    dx
                mov     dl,al
                mov     ah,2
                int     21h
                pop     dx
                ret

 include                decryptr.inc
;
 ends
;
 dataseg
;
 msg_your_name          db 13,10,'the Sweeper version 00x keygen (c) 2000 CTHC'
                        db 13,10,13,10,'Your full name : $'
 msg_organization_name  db 13,10,'Organization   : $'
 msg_your_email         db 13,10,'Your e-mail    : $'
 msg_error_creation     db 'Error creation "SWEEPER.KEY" file!$'
 sweeper_key            db 'sweeper.key',0
 string_ok              db '@.abcdefghijklmnoprstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ /-'
 numbers                db '0123456789',0
 max_string             dw ?
 string_cnt             dw ?

 include                key.inc
;
 ends
;
                end     start